%
% This file is meant as a very easy MATLAB tutorial.
%
% Just type 'matlab_tutorial' in the command window, read the text, and press any
% key to execute the command just described
%
% Author: axel kind (axel.kind@unibas.ch)
% Date: March 22, 2010

clear all
close all

disp(' ')
disp('To start a program, type the name of the program (MatlabTutorial) in the command window (without the extension .m).');
disp(' ')
disp('To continue this tutorial just press any key after each line of text.');
disp(' ')
disp('(For best learning results, you may open another MATLAB window and type the commands on your own)');
disp(' ')
pause

disp('Make sure that the file ''sp_500.txt'' is in a MATLAB path (e.g. the current path)!');
disp(' ')
pause

disp('To quit a MATLAB program while it is running, press ''Ctrl + c''');
disp(' ')
pause

disp('To clear all variables, type ''clear all''');
disp('(this is a good programming habit and can avoid many mistakes...)');
disp(' ')
pause
clear all

disp('To clear the command window, type ''clc''');
disp(' ')
pause
clc

disp('Create a variable A with a value of 3: ''A=3''');
pause
	A=3
disp(' ')

disp('To prevent Matlab from showing the result use '';'' after the command: ''A=3;''');
disp('(By pressing ''Arrow up'' you obtain previous commands)');
pause
A=3;
    disp(' ')

disp('Create a row vector B: ''B=[1 2 3]''');
pause
    B=[1 2 3]
disp(' ')

disp('Create a column vector C: ''C=[4; 5; 6]'' or ''C=transpose([4 5 6])'' or ''C=[4 5 6]'' ''');
pause
    C=[4; 5; 6]
    disp('or') 
    C=transpose([4 5 6])
    disp('or') 
    C=[4 5 6]'
disp(' ')

disp('Calculate the inner product of B and C and store it in D: ''D=B*C''');
pause
    D=B*C
disp(' ')

disp('Calculate the outer product of B and C and store it in E: ''E=C*B''');
pause
    E=C*B
disp(' ')

disp('Create two 3x3 matrices, F and G:')
disp('''F=[1 2 3; 4 5 6; 7 8 9]''');
disp('''G=[9 8 7; 6 5 4; 3 2 1]''');
pause	
    F=[1 2 3; 4 5 6; 7 8 9] 
	G=[9 8 7; 6 5 4; 3 2 1]
disp(' ')

disp('Transform matrix F into a matrix F_long with dimension 9x1:')
disp('''F_long = reshape(F,9,1)''');
pause	
F_long = reshape(F,9,1)
disp(' ')

disp('Multiply F with G and store the result in H: ''H=F*G''');
pause
    H=F*G
disp(' ')

disp('Multiply F with G element-by-element and store the result in I: ''I=F.*G''');
pause
    I=F.*G
disp(' ')

disp('Divide F through G element-by-element and store the result in L: ''L=F./G''');
pause
    L=F./G
disp(' ')

disp('Set the element (1,1) of L equal to the square root of 2: ''L(1,1)=sqrt(2)''');
pause
    L(1,1)=sqrt(2)
disp(' ')

disp('Extract the first column vector of L and store it in L_1: ''L_1=L(:,1)''');
pause
    L_1=L(:,1)
disp(' ')

disp('Extract the second row of L and store in L_2: ''L_2 = L(2,:)''');
pause
    L_2 = L(2,:)
disp(' ')

disp('Eliminate L_1 and L_2 from the worksapace: ''clear L_1 L_2''');
pause
    clear L_1 L_2
disp(' ')

disp('Concatenate matrices F and G row-wise to obtain a 3x6 matrix: ''M_2 = [F G]''');
pause
    M_2 = [F G]
disp(' ')

disp('Concatenate matrices F and G column-wise to obtain a 6x3 matrix: ''M_2 = [F; G]''');
pause
    M_2 = [F; G]
disp(' ')

disp('Create a column vector of even integers from 8 to 46: ''N = [8:2:46]''');
pause
    N = [8:2:46]'
disp(' ')

disp('Create a column vector N_sub by taking only every third element of N: ''N_sub = N(1:3:end)''');
pause
    N_sub = N(1:3:end)
disp(' ')


disp('Create a 3x3 identity matrix O: ''O = eye(3)''')
pause
	O = eye(3)
disp(' ')
    
disp('Create a 2x3 matrix of ones P: ''P = ones(2,3)''')
pause
	P = ones(2,3)
disp(' ')
    
disp('Calculate the vertical sum of the elements of P: ''Q = sum(P)''')
pause
	Q = sum(P)
disp(' ')
    
disp('Calculate the horizontal sum of the elements of P: ''Q = sum(P,2)''')
pause
	Q = sum(P,2)
disp(' ')
    
disp('Calculate the vertical cumulative sum of P: ''Q = cumsum(P,1)''')
pause
	Q = cumsum(P,1)
disp(' ')
    
disp('Calculate the horinzontal cumulative sum of P: ''Q = cumsum(P,2)''')
pause
	Q = cumsum(P,2)
disp(' ')
    
disp('Generate a 3x3 matrix with standard normally distributed random numbers: ''R = randn(3,3)''')
pause
	R = randn(3,3)
disp(' ')
    
disp('Calculate the horizontal product of R: ''S = prod(R,2)''')
pause
      S = prod(R,2)
disp(' ')
      
disp('Sort the column vector S from largest to smallest: ''S = sort(S, ''descend'')''')
pause
     S = sort(S, 'descend')
disp(' ')
     
disp('Calculate the vertical cumulative product R: ''S = cumprod(R,1)''')
pause
      S = cumprod(R,1)
disp(' ')
      
disp('Calculate the horizontal cumulative product: ''S = cumprod(R,2)''')
pause
	S = cumprod(R,2)
disp(' ')
    
disp('Flip vertically the matrix S: ''S = flipud(S)''')
pause
	S = flipud(S)
disp(' ')
    
disp('Flip horizontally the matrix S: ''S = fliplr(S)''')
pause
	S = fliplr(S)
disp(' ')

disp('Generate a loop with the ''For'' statement:') ;
disp('''a=0;''');
disp('''for i=10:-0.5:1''');
disp('''   a=a+1''');
disp('''end''');
pause
a=0;
for i=10:-0.5:1
	a=a+1
end
disp(' ')

disp('Use the ''if'' statement:');
disp('''a=3;''');
disp('''if (a<=3) & (a>1)''');
disp('''   disp(''if-condition is satisfied'');''');
disp('''end''');
disp(' ')
pause
a=3;
if (a<=3) & (a>1)
	disp('if-condition is satisfied');
end
disp(' ')

disp('Import data from the file ''sp_500.txt'' and store it in the matrix ''price_data'':');
disp('''price_data = importdata(''sp_500.txt'','' '');''');
pause 
	price_data = importdata('sp_500.txt',' ');
disp(' ')

disp('Calculate the series of log returns and save them in a vector called ''sp500ReturnV'':');
disp('''sp500ReturnV = log(price_data(2:end,2)) - log(price_data(1:end-1,2));''');
pause
    sp500ReturnV = log(price_data(2:end,2)) - log(price_data(1:end-1,2));
disp(' ')

disp('Create a vector called ''dateV'' with the dates corresponding to the S&P returns:');
disp('''dateV = price_data(2:end,1);''');
pause
    dateV = price_data(2:end,1)+ datenum(1899,12,30);
disp(' ')

disp('Calculate the annualized average and standard deviation from daily returns on the S&P 500 and');
disp('save them with an appropriate comment in a .txt file :');
disp('''result(1) = mean(sp500ReturnV)*250;''');
disp('''result(2) = std(sp500ReturnV)*sqrt(250);''');
disp('''fid = fopen(''MyResults.txt'',''w'');''');
disp('''fprintf(fid,''The annualized mean return of the S&P is %2.2f percent. \n'',100*result(1));''');
disp('''fprintf(fid,''The annualized standard deviation of the S&P is %2.2f percent. \n'',100*result(2));''');
disp('''fclose(fid);''');

pause
result(1) = mean(sp500ReturnV)*250;
result(2) = std(sp500ReturnV)*sqrt(250);
fid = fopen('my_results.txt','w');
fprintf(fid,'The annualized mean return of the S&P is %2.2f percent. \n',100*result(1));
fprintf(fid,'The annualized standard deviation of the S&P is %2.2f percent. \n',100*result(2));
fclose(fid);
disp(' ')

disp('Plot daily returns together with two-sigma bounds:');
disp('''figure''');
disp('''plot(dateV,sp500ReturnV,''-b'',''LineWidth'',1);''');
disp('''hold on''');
disp('''lower_bound = mean(sp500ReturnV)-2*std(sp500ReturnV)''');
disp('''upper_bound = mean(sp500ReturnV)+2*std(sp500ReturnV)''');
disp('''plot(dateV,lower_bound*ones(length(sp500ReturnV),1),'':r'',''LineWidth'',2);''');
disp('''plot(dateV,upper_bound*ones(length(sp500ReturnV),1),''-r'',''LineWidth'',2);''');

pause
    figure
    plot(dateV,sp500ReturnV,'-b','LineWidth',1);
    hold on
    lower_bound = mean(sp500ReturnV)-2*std(sp500ReturnV);
    upper_bound = mean(sp500ReturnV)+2*std(sp500ReturnV);
    plot(dateV,lower_bound*ones(length(sp500ReturnV),1),':r','LineWidth',2);
    plot(dateV,upper_bound*ones(length(sp500ReturnV),1),'-r','LineWidth',2);
disp(' ');

disp('Improve the readability of the graph by describing axes, and by adding a legend and a title:');
disp('''ylabel(''Daily S&P returns'',''fontSize'',14);''');
disp('''xlabel(''Time'',''fontSize'',14);''');
disp('''datetick(''x'',12,''keepticks'');''');
disp('''[legend_h,object_h,plot_h,text_strings]=legend(''S&P returns'',''lower two-sigma bound'',''upper two-sigma bound'',2);''');
disp('''set(legend_h,''fontSize'',14);''');
disp('''legend(legend_h,''boxoff'');''');
disp('''title(''S&P Returns'',''fontSize'',14);''');
pause
    ylabel('Daily S&P returns','fontSize',14);
    xlabel('Time','fontSize',14);
    datetick('x',12,'keepticks');
    [legend_h,object_h,plot_h,text_strings]=legend('S&P returns','lower two-sigma bound','upper two-sigma bound',4);
    set(legend_h,'fontSize',14);
    legend(legend_h,'boxoff');
    title('S&P Returns','fontSize',14);
disp(' ')

disp('Save the graph in .jpg format and .eps format (for importing into .tex files):');
disp('''saveas(gcf,''sp500Graph.jpg'',''jpg'');''');
disp('''saveas(gcf,''sp500Graph.eps'',''psc2'');''');
pause
    saveas(gcf,'sp500Graph.jpg','jpg');
    saveas(gcf,'sp500Graph.eps','psc2');
disp(' ')

disp('Find the dates when S&P returns where lower than 2 standard deviations:');
disp('''index_sp = find(sp500ReturnV < lower_bound);''');
disp('''datestr(datevec(dateV(index_sp,1), 22))''');
disp('''n = length(dateV(index_sp,1))''');
pause
    index_sp = find(sp500ReturnV < lower_bound);
    datestr(dateV(index_sp), 22)
    n = length(dateV(index_sp))
disp(' ')

disp('To what percentage does this correspond?');
disp('''percentage = length(return_data(index_sp))/length(sp500ReturnV)''');
pause
    percentage = length(sp500ReturnV(index_sp))/length(sp500ReturnV)
disp(' ')

disp(' ')
disp('This short MATLAB tutorial is over.')