function [meanValue, standardDeviation] = MeanStandardDeviation(matrix)
%
%   [meanValue, standardDeviation] = MeanStandardDeviation(matrix)
%
% EXPLANATION: This function calculates the mean and the standard deviation of a matrix
%
% INPUT:
%  - matrix = arbitrary n x m matrix
%
% OUTPUT:
% - meanValue = mean of the matrix
% - standardDeviation = standard deviation of the matrix (optional)
%
% EXAMPLE: 
% - meanValue = MeanVar(rand(10,1))
% - [meanValue, standardDeviation] = MeanStandardDeviation(rand(10,1))
%
% Axel Kind, axel.kind@unibas.ch, 18/03/2010
%
n = size(matrix,1);
meanValue = mean(matrix);
if nargout > 1
    standardDeviation = std(matrix);
end
