function [] = RussianRoulette(nPlayer)
%
% void = RussianRoulette(nPlayers,rouletteType)
%
% This function simulates a Russian Roulette game with a classical six-shot
% revolver.
%
% INPUT:
% - nPlayers = Number of players (positive integer) 
%
% OUTPUT: 		nothing (void), simply a screen and figure output
%
% EXAMPLE:      RussianRoulette(6)
%
% Axel Kind, axel.kind@unibas.ch, 21/03/2010, University of Basel 
%
clc, slots = 6; alive = 1;
[win, winMap] = imread('dove.jpg');
[lose, loseMap] = imread('death4.jpg');
[yShot, FsShot] = wavread('shot.wav');
[yEmptyChamber, FsEmptyChamber] = wavread('emptychamber.wav');
[ySpin, FsSpin] = wavread('spin.wav');
[ySpan, FsSpan] = wavread('span.wav');
fprintf('\nThere are %1.0f players in this game.\n\n',nPlayer);

for iPlayer = 1:nPlayer
    fprintf('Player %1.0f, it is your turn. Spin the cylinder of the revolver and shoot by pressing ''enter''!\n\n',iPlayer);
    pause, close
    if slots == 6, wavplay(ySpan, FsSpan), pause(1.0), wavplay(ySpin, FsSpin), pause(0.5+2*rand)
    else
        pause(1.0), wavplay(ySpan, FsSpan), pause(0.5+2*rand)
    end
    if rand >= 1/slots
        wavplay(yEmptyChamber, FsEmptyChamber)
        figure, image(win), title(sprintf('Congratulations, Player %1.0f, you are still alive!',iPlayer),'FontSize',14), axis off
        alive = 1;
    else
        wavplay(yShot, FsShot)
        figure, image(lose), title(sprintf('This is a sad moment, Player %1.0f left us!',iPlayer),'FontSize',14), axis off
        alive = 0;     
    end
    if slots == 2 | alive == 0; 
        slots = 6; 
    else
        slots = slots - 1;
    end
end
fprintf('THE GAME IS OVER! \n');