function value = rmse(x,y)
%
% value = rmse(x,y)
%
% This function calculates the root mean squared error between two vectors
%
% INPUT:		x = N*1 vector
%				y = N*1 vector
%
% OUTPUT: 		value = root mean squared error (scalar)
%
% EXAMPLE:      A = rmse([0.01 0.03 0.03 -0.01]', [0.0 0.02 0.01 -0.02]')
%
% Axel Kind, axel.kind@unibas.ch, 15/02/2009
%
	value = sqrt(mean((x-y).^2));
end 